package com.dsic.gj_erp.controller.jcsj;


import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/emSbcnp")
@Api(tags = "设备产能")
public class EmSbcnpController {
    @Autowired
    EmSbcnpService emSbcnpService;

    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody JSONObject json) {
        List<EmSbcnp> emSbcnps= emSbcnpService.getList(json);
        return new ResultBean(emSbcnps);
    }

    @ApiOperation(value = "批量新增")
    @PostMapping(value = "/save")
    @AuthFunction
    public ResultBean save(@RequestBody List<EmSbcnp> emSbcnps, HttpServletRequest req) {
        String username=(String) req.getAttribute("yhms");
        String day= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        emSbcnps.forEach(l->{
            l.setBjry(username);
            l.setBjrq(day);
        });
        emSbcnpService.saveBatch(emSbcnps);

        return new ResultBean();
    }

    @ApiOperation(value = "批量修改")
    @PostMapping(value = "/update")
    @AuthFunction
    public ResultBean update(@RequestBody List<EmSbcnp> emSbcnps, HttpServletRequest req) {
        String username=(String) req.getAttribute("yhms");
        String day= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        emSbcnps.forEach(l->{
            l.setBjry(username);
            l.setBjrq(day);
        });
        emSbcnpService.updateBatchById(emSbcnps);

        return new ResultBean();
    }

    @ApiOperation(value = "批量删除")
    @PostMapping(value = "/delete")
    public ResultBean delete(@RequestBody List<EmSbcnp> sbjbbs) {
        emSbcnpService.delete(sbjbbs);

        return new ResultBean();
    }
}

