package com.dsic.gj_erp.pc.dto.gx;

import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.dto.工序产能;
import com.dsic.gj_erp.pc.dto.设备;
import lombok.Getter;
import lombok.Setter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Map;
import java.util.Optional;

@Getter
@Setter
public class 工序05切割 extends 工序产能 {

    private static final Logger log = LoggerFactory.getLogger(工序05切割.class);

    public 工序05切割(Map<String, 设备> _设备) {
        super(Constant.工序.切割,_设备);
    }

    @Override
    public void 计算工作量() {
        this.产能=0;
        this.设备.values().forEach(设备->{
            设备.修正工作量(this.白班时长,this.二班时长);
            this.产能+=设备.get产能();
        });
    }

    @Override
    public void 占用设备(String 占用源,double 所需产能, Bom bom){
        if (!bom.判断是否为可识别跨位和切割设备的套料图()){
            this.强占设备(bom.getTzbh(),1,bom);
            return;
        }
        Optional<设备> 可占用设备 = this.获取可占用设备(bom.获取套料图分类码(),所需产能);
        if (!可占用设备.isPresent()){
            log.info("强占:{}",bom);
            bom.超出工序产能(Constant.工序.切割);
            this.强占设备(bom.getTzbh(),1,bom);
        }
        可占用设备.ifPresent(it->{
            it.占用设备(所需产能);
            it.占用设备(bom);
        });
    }

    @Override
    public Optional<设备> 获取可占用设备(String 套料图分类码,double 所需产能){
        return this.设备.values().stream()
                .filter(item->item.getKey().contains(套料图分类码)&&item.get占用()+所需产能<=this.产能).findFirst();
    }

    @Override
    public void 占用资源(double 所需产能) {
        super.占用资源(所需产能);
    }
}
